import Ajv from 'ajv/dist/2020';
import { JSONSchema7 } from 'json-schema';
import { ParseError } from './ParseError';
import { ValidateFunction } from 'ajv';
import { Result } from 'defekt';
interface ParserOptions {
    ajvInstance: Ajv;
}
declare class Parser<TParsed> {
    protected validateInternal: ValidateFunction;
    constructor(schema: JSONSchema7, { ajvInstance }?: ParserOptions);
    parse(unparsedValue: any, { valueName, separator }?: {
        valueName?: string;
        separator?: string;
    }): Result<TParsed, ParseError>;
    isValid(unparsedValue: any): boolean;
}
export { Parser };
